#!/usr/bin/perl -w

$confGmetric = "/usr/bin/gmetric --tmax=700";
$confSensors = "/usr/bin/sensors";
$confGanglia = "/etc/gmond.conf";

die "Ganglia is not installed"  if ! -r $confGanglia;
die "Sensors are not installed" if ! (-e "/proc/bus/i2c" || -e "/sys/bus/i2c/drivers/i2c_adapter");

$ip   = "239.2.11.71";
$port = "8649";

open(IN,"$confGanglia") || die "Cannot read $confGanglia";
while (<IN>)
  {
    next if /^#/;
    $ip   = $1 if /mcast_channel +(.*)/;
    $port = $1 if /mcast_port +(.*)/;
  }
close IN;

$sensorData = `$confSensors`;

#$sensorData =~ s/\xb0/x/sg;
#$sensorData =~ s/.C/ x/sg;
#$sensorData =~ s/\x43/x/sg;

#print $sensorData;

foreach my $entry (split(/\n/,$sensorData))
  {
    #print "-> $entry\n";

    #if ($entry =~ /^(.*)\:\s+\+([\d\.]+).C/)
    if ($entry =~ /^(.*)\:\s*[ \+\-]([\d\.]+).(\w+)/)
      {
	my $key = $1;
	my $val = $2;
	my $unit = $3;

	$key =~ s/\+/plus /;
	$key =~ s/\-/minus /;

	#print "[$entry] [$key] [$val]\n";

	my $cmd = "$confGmetric -c$ip -p$port -tfloat -n\"sensor $key\" -u$unit -v$val";
	#print "$cmd\n";
	system $cmd;
      }
  }

exit 0;
#end file
